> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://notion.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://notion.ferndocs.com/_mcp/server.

# Retrieve block children

GET https://api.notion.com/v1/blocks/{block_id}/children

Returns a paginated array of child [block objects](/reference/block) contained in the block using the ID specified. In order to receive a complete representation of a block, you may need to recursively retrieve the block children of child blocks.

Page content is represented by block children. See the [Working with page content guide](https://developers.notion.com/docs/working-with-page-content#modeling-content-as-blocks) for more information.

Returns only the first level of children for the specified block. See [block objects](/reference/block) for more detail on determining if that block has nested children.

The response may contain fewer than `page_size` of results.

See [Pagination](https://developers.notion.com/reference/intro#pagination) for details about how to use a cursor to iterate through the list.

This endpoint requires an integration to have read content capabilities. Attempting to call this API without read content capabilities will return an HTTP response with a 403 status code. For more information on integration capabilities, see the [capabilities guide](/reference/capabilities).

### Errors

Returns a 404 HTTP response if the block specified by `id` doesn't exist, or if the integration doesn't have access to the block.

Returns a 400 or 429 HTTP response if the request exceeds the [request limits](/reference/request-limits).

*Note: Each Public API endpoint can return several possible error codes. See the [Error codes section](https://developers.notion.com/reference/status-codes#error-codes) of the Status codes documentation for more information.*

Reference: https://notion.ferndocs.com/reference/get-block-children

## Request

### Path parameters

- `block_id` (string, required) — Identifier for a [block](ref:block)

### Query parameters

- `start_cursor` (string, optional) — If supplied, this endpoint will return a page of results starting after the cursor provided. If not supplied, this endpoint will return the first page of results.
- `page_size` (integer, optional, default: 100) — The number of items from the full list desired in the response. Maximum: 100

### Headers

- `Notion-Version` (string, required) — The [API version](/reference/versioning) to use for this request. The latest version is `<<latestNotionVersion>>`.

## Response

### 200

200

- `object` (string, optional)
- `results` (list of V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItems, optional)
- `next_cursor` (any, optional)
- `has_more` (boolean, optional, default: true)
- `type` (string, optional)
- `block` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaBlock, optional)

## Errors

### 400 Bad Request Error

400

## Types

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItems

- `object` (string, optional)
- `id` (string, optional)
- `parent` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsParent, optional)
- `created_time` (string, optional)
- `last_edited_time` (string, optional)
- `created_by` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsCreatedBy, optional)
- `last_edited_by` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsLastEditedBy, optional)
- `has_children` (boolean, optional, default: true)
- `archived` (boolean, optional, default: true)
- `type` (string, optional)
- `heading_2` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2, optional)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaBlock

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsParent

- `type` (string, optional)
- `page_id` (string, optional)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsCreatedBy

- `object` (string, optional)
- `id` (string, optional)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsLastEditedBy

- `object` (string, optional)
- `id` (string, optional)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2

- `rich_text` (list of V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2RichTextItems, optional)
- `color` (string, optional)
- `is_toggleable` (boolean, optional, default: true)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2RichTextItems

- `type` (string, optional)
- `text` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2RichTextItemsText, optional)
- `annotations` (V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2RichTextItemsAnnotations, optional)
- `plain_text` (string, optional)
- `href` (any, optional)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2RichTextItemsText

- `content` (string, optional)
- `link` (any, optional)

### V1BlocksBlockIdChildrenGetResponsesContentApplicationJsonSchemaResultsItemsHeading2RichTextItemsAnnotations

- `bold` (boolean, optional, default: true)
- `italic` (boolean, optional, default: true)
- `strikethrough` (boolean, optional, default: true)
- `underline` (boolean, optional, default: true)
- `code` (boolean, optional, default: true)
- `color` (string, optional)

## Examples

**Response**

```json
{
  "Result": {
    "value": "{\n\t\"object\": \"list\",\n\t\"results\": [\n\t\t{\n\t\t\t\"object\": \"block\",\n\t\t\t\"id\": \"c02fc1d3-db8b-45c5-a222-27595b15aea7\",\n\t\t\t\"parent\": {\n\t\t\t\t\"type\": \"page_id\",\n\t\t\t\t\"page_id\": \"59833787-2cf9-4fdf-8782-e53db20768a5\"\n\t\t\t},\n\t\t\t\"created_time\": \"2022-03-01T19:05:00.000Z\",\n\t\t\t\"last_edited_time\": \"2022-03-01T19:05:00.000Z\",\n\t\t\t\"created_by\": {\n\t\t\t\t\"object\": \"user\",\n\t\t\t\t\"id\": \"ee5f0f84-409a-440f-983a-a5315961c6e4\"\n\t\t\t},\n\t\t\t\"last_edited_by\": {\n\t\t\t\t\"object\": \"user\",\n\t\t\t\t\"id\": \"ee5f0f84-409a-440f-983a-a5315961c6e4\"\n\t\t\t},\n\t\t\t\"has_children\": false,\n\t\t\t\"archived\": false,\n\t\t\t\"type\": \"heading_2\",\n\t\t\t\"heading_2\": {\n\t\t\t\t\"rich_text\": [\n\t\t\t\t\t{\n\t\t\t\t\t\t\"type\": \"text\",\n\t\t\t\t\t\t\"text\": {\n\t\t\t\t\t\t\t\"content\": \"Lacinato kale\",\n\t\t\t\t\t\t\t\"link\": null\n\t\t\t\t\t\t},\n\t\t\t\t\t\t\"annotations\": {\n\t\t\t\t\t\t\t\"bold\": false,\n\t\t\t\t\t\t\t\"italic\": false,\n\t\t\t\t\t\t\t\"strikethrough\": false,\n\t\t\t\t\t\t\t\"underline\": false,\n\t\t\t\t\t\t\t\"code\": false,\n\t\t\t\t\t\t\t\"color\": \"default\"\n\t\t\t\t\t\t},\n\t\t\t\t\t\t\"plain_text\": \"Lacinato kale\",\n\t\t\t\t\t\t\"href\": null\n\t\t\t\t\t}\n\t\t\t\t],\n\t\t\t\t\"color\": \"default\",\n        \"is_toggleable\": false\n\t\t\t}\n\t\t},\n\t\t{\n\t\t\t\"object\": \"block\",\n\t\t\t\"id\": \"acc7eb06-05cd-4603-a384-5e1e4f1f4e72\",\n\t\t\t\"parent\": {\n\t\t\t\t\"type\": \"page_id\",\n\t\t\t\t\"page_id\": \"59833787-2cf9-4fdf-8782-e53db20768a5\"\n\t\t\t},\n\t\t\t\"created_time\": \"2022-03-01T19:05:00.000Z\",\n\t\t\t\"last_edited_time\": \"2022-03-01T19:05:00.000Z\",\n\t\t\t\"created_by\": {\n\t\t\t\t\"object\": \"user\",\n\t\t\t\t\"id\": \"ee5f0f84-409a-440f-983a-a5315961c6e4\"\n\t\t\t},\n\t\t\t\"last_edited_by\": {\n\t\t\t\t\"object\": \"user\",\n\t\t\t\t\"id\": \"ee5f0f84-409a-440f-983a-a5315961c6e4\"\n\t\t\t},\n\t\t\t\"has_children\": false,\n\t\t\t\"archived\": false,\n\t\t\t\"type\": \"paragraph\",\n\t\t\t\"paragraph\": {\n\t\t\t\t\"rich_text\": [\n\t\t\t\t\t{\n\t\t\t\t\t\t\"type\": \"text\",\n\t\t\t\t\t\t\"text\": {\n\t\t\t\t\t\t\t\"content\": \"Lacinato kale is a variety of kale with a long tradition in Italian cuisine, especially that of Tuscany. It is also known as Tuscan kale, Italian kale, dinosaur kale, kale, flat back kale, palm tree kale, or black Tuscan palm.\",\n\t\t\t\t\t\t\t\"link\": {\n\t\t\t\t\t\t\t\t\"url\": \"https://en.wikipedia.org/wiki/Lacinato_kale\"\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t},\n\t\t\t\t\t\t\"annotations\": {\n\t\t\t\t\t\t\t\"bold\": false,\n\t\t\t\t\t\t\t\"italic\": false,\n\t\t\t\t\t\t\t\"strikethrough\": false,\n\t\t\t\t\t\t\t\"underline\": false,\n\t\t\t\t\t\t\t\"code\": false,\n\t\t\t\t\t\t\t\"color\": \"default\"\n\t\t\t\t\t\t},\n\t\t\t\t\t\t\"plain_text\": \"Lacinato kale is a variety of kale with a long tradition in Italian cuisine, especially that of Tuscany. It is also known as Tuscan kale, Italian kale, dinosaur kale, kale, flat back kale, palm tree kale, or black Tuscan palm.\",\n\t\t\t\t\t\t\"href\": \"https://en.wikipedia.org/wiki/Lacinato_kale\"\n\t\t\t\t\t}\n\t\t\t\t],\n\t\t\t\t\"color\": \"default\"\n\t\t\t}\n\t\t}\n\t],\n\t\"next_cursor\": null,\n\t\"has_more\": false,\n\t\"type\": \"block\",\n\t\"block\": {}\n}"
  }
}
```

**SDK Code**

```javascript Notion SDK for JavaScript
const { Client } = require('@notionhq/client');

const notion = new Client({ auth: process.env.NOTION_API_KEY });

(async () => {
  const blockId = '59833787-2cf9-4fdf-8782-e53db20768a5';
  const response = await notion.blocks.children.list({
    block_id: blockId,
    page_size: 50,
  });
  console.log(response);
})();
```

```python
import requests

url = "https://api.notion.com/v1/blocks/block_id/children"

headers = {"Notion-Version": "Notion-Version"}

response = requests.get(url, headers=headers)

print(response.json())
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.notion.com/v1/blocks/block_id/children"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Notion-Version", "Notion-Version")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.notion.com/v1/blocks/block_id/children")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Notion-Version"] = 'Notion-Version'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.notion.com/v1/blocks/block_id/children")
  .header("Notion-Version", "Notion-Version")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.notion.com/v1/blocks/block_id/children', [
  'headers' => [
    'Notion-Version' => 'Notion-Version',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.notion.com/v1/blocks/block_id/children");
var request = new RestRequest(Method.GET);
request.AddHeader("Notion-Version", "Notion-Version");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Notion-Version": "Notion-Version"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.notion.com/v1/blocks/block_id/children")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```